
INCLUDE "psocgpioint.inc"
INCLUDE "memory.inc"
INCLUDE "GlobalParams.inc"
 INCLUDE "m8c.inc"
 ; ----------------------------------------------------------------------------
; Disable or enable the code compressor. Redefining here allows them to be 
; easily no-op'd.
; ----------------------------------------------------------------------------
MACRO   DISABLE_CODE_COMPRESSION
        Suspend_CodeCompressor
ENDM
MACRO   ENABLE_CODE_COMPRESSION
        Resume_CodeCompressor
ENDM
		
        AREA SSCParmBlkA(RAM,ABS)
		
org F8h                       ; Variables are defined starting at address F8h
SSC_KEY1:                     ; F8h supervisory key
SSC_RETURNCODE: blk 1         ; F8h result code
SSC_KEY2 : blk 1              ;F9h supervisory stack ptr key
SSC_BLOCKID: blk 1            ; FAh block ID
SSC_POINTER: blk 1            ; FBh pointer to data buffer
SSC_CLOCK: blk 1              ; FCh Clock
SSC_MODE: blk 1               ; FDh ClockW ClockE multiplier
SSC_DELAY: blk 1              ; FEh flash macro sequence delay count
SSC_WRITE_ResultCode: blk 1   ; FFh temporary result code


		AREA    UserModules (ROM, REL)
        DISABLE_CODE_COMPRESSION        ; Code breaks if "subroutinized".

.SECTION
;-----------------------------------------------------------------------------
; Function Name: void SROMTableRead(BYTE tableNo)
;-----------------------------------------------------------------------------
; Summary:
; This function .
;
;-----------------------------------------------------------------------------
; Parameters:
; A: SROM Table number
; X: Unused
;
; Return:
; A: ReadStatus
; X: Undefined
;
; Theory:
; 
; Side Effects:
;
; Note:
;-----------------------------------------------------------------------------
 SROMTableRead::
_SROMTableRead::
    RAM_SETPAGE_CUR >RadioDriverRamPage

	mov [SSC_BLOCKID], A   ; To read from Table 0 - Silicon ID is stored in Table 0
	
	;Call SROM operation to read the SROM table
	mov X, SP              ; copy SP into X
	mov A, X               ; A temp stored in X
	add A, 3               ; create 3 byte stack frame (2 + pushed A)
	mov [SSC_KEY2], A      ; save stack frame for supervisory code

	; load the supervisory code for flash operations
	mov [SSC_KEY1], 3Ah    ;FLASH_OPER_KEY - 3Ah
	mov A,6                ; load A with specific operation. 06h is the code for Table read Table 9-1
	SSC                    ; SSC call the supervisory ROM
	; At the end of the SSC command the silicon ID is stored in F8 (MSB) and F9(LSB) of the SRAM
    ret
.ENDSECTION

    ENABLE_CODE_COMPRESSION
